unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Image1: TImage;
    Button1: TButton;
    Label1: TLabel;
    Label2: TLabel;
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  xs,ys,strom:array[1..20]of integer;
  g:array[1..20,1..20]of integer;
  n,i,j,min,z,k,pomoc1,pomoc2:integer;
  koniec:boolean;

implementation

{$R *.dfm}

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if n<20 then
    begin
      Label1.Visible:=False;
      Label2.Visible:=False;
      Image1.Canvas.Ellipse(x-5,y-5,x+5,y+5);
      inc(n);
      xs[n]:=x;
      ys[n]:=y;
    end;  
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Image1.Enabled:=False;
  {vypocet vzdialenosti}
  for i:=1 to n do
    for j:=1 to n do
      g[i,j]:=round(sqrt((xs[i]-xs[j])*(xs[i]-xs[j])+
                         (ys[i]-ys[j])*(ys[i]-ys[j])));
  {prislusnost ku stromu}
  for i:=1 to n do strom[i]:=i;
  koniec:=false;
  repeat
    {najdenie minimalnej hrany}
    min:=1000000;
    for i:=1 to n do
      for j:=1 to n do
        if (g[i,j]<min)and(strom[i]<>strom[j]) then
          begin
            min:=g[i,j];
            z:=i;
            k:=j;
          end;
    {zaradenie minimalnej hrany do kostry}
    Image1.Canvas.MoveTo(xs[z],ys[z]);
    Image1.Canvas.LineTo(xs[k],ys[k]);
    pomoc1:=strom[z];pomoc2:=strom[k];
    for i:=1 to n do
      if pomoc2=strom[i] then strom[i]:=pomoc1;
    {kontrola konca algoritmu - ci su vsetky vrcholy v 1. strome}
    koniec:=true;
    for i:=2 to n do
      if strom[i]<>strom[1] then koniec:=false;  
  until koniec;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Image1.Canvas.Rectangle(1,1,400,400);
end;

end.
